package coffeetronix;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;



/**
 * This is the little happy Projects GUI-window.
 * 
 * It is created and can easily maintained with the 
 * trial verson of the Borland(TM) JBuilder.
 * It is the window for managing the coffeetronix 
 * projects and directories.
 *
 * @author Rene Stoeckel (rene.stoeckel-at-web.de)
 *
 */

public class ProjectsGUI extends JFrame implements ListSelectionListener
{
	
	private JavaProject project= null;
	
	private DefaultListModel dlm= new DefaultListModel();
	private DefaultListModel dlm_projectsources= new DefaultListModel();
	private JList jList1= new JList(dlm);

	protected JTextField tf_projectname= new JTextField();
	private JScrollPane jScrollPane1= new JScrollPane();

	private JLabel jLabel1= new JLabel();
	private JButton btn_save= new JButton();
	private JButton btn_delete= new JButton();
	private JList jList2= new JList(dlm_projectsources);
	private JScrollPane jScrollPane2= new JScrollPane();
	private JButton btn_add= new JButton();
	private JButton btn_remove= new JButton();
	private JLabel jLabel2= new JLabel();
	private JButton btn_open= new JButton();
	private JButton dismiss= new JButton();
	private JLabel jLabel3= new JLabel();
	protected JTextField tf_projecthome= new JTextField();
	private JButton btn_browse= new JButton();

	public ProjectsGUI(JavaProject project)
	{
		super("Coffeetronix Projects");
		this.project = project;
		try
		{
			jbInit();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void reload()
	{
		System.out.println("Reloading!");
		if (project == null)
			return;
		project.reload();
	}


	/** 
	 * Private method that fills the projects listbox. project collections
	 * are to be provided by overriding getProjects().
	 */
	private void loadprojects()
	{
		dlm.removeAllElements();

		// get the projects from ProjectsList
		String arr[]= getProjects();
		
		if (arr == null)
			dlm.addElement("projects not found!");
		else
			for (int n= 0; n < arr.length; n++)
				dlm.addElement(arr[n]);

	}

	private void jbInit() throws Exception
	{

		this.setSize(new Dimension(500, 529));
		this.getContentPane().setLayout(null);
		tf_projectname.setBounds(new Rectangle(28, 34, 148, 23));
		jScrollPane1.setBounds(new Rectangle(29, 65, 147, 136));
		jLabel1.setText("Java Source Dirs:");
		jLabel1.setBounds(new Rectangle(29, 268, 117, 21));

		btn_save.setText("Save");
		btn_save.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_save(e);
			}
		});
		btn_save.setBounds(new Rectangle(189, 95, 73, 22));
		btn_delete.setText("Delete");
		btn_delete.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_delete(e);
			}
		});
		btn_delete.setBounds(new Rectangle(189, 124, 73, 22));
		jScrollPane2.setBounds(new Rectangle(28, 298, 429, 140));
		btn_add.setText("Add ...");
		btn_add.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_add(e);
			}
		});
		btn_add.setBounds(new Rectangle(133, 269, 81, 22));
		btn_remove.setText("Remove");
		btn_remove.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_remove(e);
			}
		});
		btn_remove.setBounds(new Rectangle(221, 269, 91, 22));
		jLabel2.setBounds(new Rectangle(29, 10, 117, 21));
		jLabel2.setText("Projects:");
		btn_open.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_open(e);
			}
		});
		btn_open.setText("Open");
		btn_open.setBounds(new Rectangle(272, 175, 91, 22));
		dismiss.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_dismiss(e);
			}
		});
		dismiss.setText("Dismiss");
		dismiss.setBounds(new Rectangle(368, 175, 88, 22));
		jLabel3.setText("Project Home Dir:");
		jLabel3.setBounds(new Rectangle(28, 209, 117, 21));
		tf_projecthome.setBounds(new Rectangle(28, 227, 335, 21));
		tf_projecthome.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_projectHome(e);
			}
		});
		btn_browse.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				action_browse(e);
			}
		});
		btn_browse.setText("Browse ...");
		btn_browse.setBounds(new Rectangle(369, 226, 88, 22));
		this.getContentPane().add(tf_projectname, null);
		this.getContentPane().add(jScrollPane1, null);
		this.getContentPane().add(btn_save, null);
		this.getContentPane().add(btn_delete, null);
		this.getContentPane().add(jLabel2, null);
		this.getContentPane().add(jLabel3, null);
		this.getContentPane().add(tf_projecthome, null);
		this.getContentPane().add(jLabel1, null);
		this.getContentPane().add(btn_remove, null);
		this.getContentPane().add(btn_add, null);
		this.getContentPane().add(jScrollPane2, null);
		this.getContentPane().add(btn_browse, null);
		this.getContentPane().add(dismiss, null);
		this.getContentPane().add(btn_open, null);
		jScrollPane2.getViewport().add(jList2, null);
		jScrollPane1.getViewport().add(jList1, null);

		jList1.addListSelectionListener(this);

		loadprojects();

	}

	public void valueChanged(ListSelectionEvent e)
	{
		if (!e.getValueIsAdjusting()) return;
		JList lsm = (JList)e.getSource();
		if (lsm != null)
		{
			action_load(null);
		}
	}


	public String getSelectedProject()
	{
		return jList1.getSelectedValue().toString();
	}
	
	public String getSelectedSourceDir()
	{
		return jList2.getSelectedValue().toString();
	}
	

	public void setProjectName(String in)
	{
		tf_projectname.setText(in);
	}

	public void setProjectHome(String in)
	{
		tf_projecthome.setText(in);
	}
	
	public String getProjectHome()
	{
		return tf_projecthome.getText();
	}

	private void setProjectSourceDirs(Collection c)
	{
		dlm_projectsources.removeAllElements();
		for (Iterator iter= c.iterator(); iter.hasNext();)
			dlm_projectsources.addElement(iter.next());
	}

	/** 
	 * 
	 * part of the interface to be overloaded 
	 *
	 **/
	void action_remove(ActionEvent e)
	{
		String newdir= getSelectedSourceDir();
		// update project
		project.removeSourceDir(newdir);
		// update gui
		setProjectSourceDirs(project.getProjectSources());
	}

	/** 
	 * 
	 *part of the interface to be overloaded 
	 */
	void action_add(ActionEvent e)
	{
		try
		{
			JFileChooser fchooser= new JFileChooser(getProjectHome());

			fchooser.setFileHidingEnabled(true);
			fchooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

			// CANCEL pressed ?
			if (JFileChooser.APPROVE_OPTION
				!= fchooser.showOpenDialog(new JFrame()))
				return;

			File f= fchooser.getSelectedFile();

			File fhome= new File(getProjectHome());
			
			String strhome= fhome.getCanonicalPath();
			String newdir= f.getCanonicalPath();

			// cut off the projects home path to get a relative directory
			if (newdir.equals(strhome))
			{
				newdir= ".";
			}
			
			else
			{
				newdir= newdir.substring(strhome.length() + 1, newdir.length());
				newdir= newdir.replace('\\', '/');
			}
			
			project.addSourceDir(newdir);
			setProjectSourceDirs(project.getProjectSources());
			ErrorSystem.info("added source dir:" + newdir);

		}
		catch (IOException e1)
		{
		}

	}

	/** part of the interface to be overloaded */
	void action_browse(ActionEvent e)
	{
		try
		{
			JFileChooser fchooser= new JFileChooser(getProjectHome());

			fchooser.setFileHidingEnabled(true);
			fchooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			// CANCEL pressed ?
			if (JFileChooser.APPROVE_OPTION
				!= fchooser.showOpenDialog(new JFrame()))
				return;

			File f= fchooser.getSelectedFile();
			project.setProjectHome(f.getCanonicalPath());
		}
		catch (IOException e1)
		{
		}
	}

	/** part of the interface to be overloaded */
	void action_save(ActionEvent e)
	{
		project.setFileName("projects/" + tf_projectname.getText());
		project.setProjectHome(tf_projecthome.getText());
		project.save();
		loadprojects();
	}



	/** part of the interface to be overloaded */
	void action_open(ActionEvent e)
	{
		hide();

		project.constructDiagram();

	}

	/** part of the interface to be overloaded */
	void action_dismiss(ActionEvent e)
	{
		hide();
	}


	/** part of the interface to be overloaded */
	void action_load(ActionEvent _null)
	{
		ErrorSystem.info("loading project " + getSelectedProject());

		setProjectName(getSelectedProject());
		project.load(new File("projects" + "/" + getSelectedProject()));

		setProjectHome(project.getProjectHome());
		setProjectSourceDirs(project.getProjectSources());

	}

	/** part of the interface to be overloaded */
	void action_delete(ActionEvent _null)
	{
	}
	
	
	/** part of the interface to be overloaded */

	void action_projectHome(ActionEvent _null)
	{
		System.out.println("new projects home: " + getProjectHome());
	}
	
	/** part of the interface to be overloaded */
	protected String[] getProjects()
	{
		File f= new File("projects");

		if (!f.exists())
			return null;
		if (!f.isDirectory())
			return null;
			
		String arr[] = f.list(new FilenameFilter()
		{
			public boolean accept(File f, String s)
			{
				return s.endsWith(".ctx");
			}
		});
		
		Arrays.sort(arr);
		return arr;
		
	}
	
}