package coffeetronix.diagram;



/** 
 * This is a link in the class diagram 
 * 
 * @author Rene Stoeckel (rene.stoeckel-at-web.de)
 */

public class Link
{

	/** Shape where the link comes from */
	public LinkInfo from;

	/** Shape where the link goes to */
	public LinkInfo to;

	public int type;
	
	public static final int TYPE_ASSOCIATION=0;
	public static final int TYPE_GENERALIZATION=1;
	public static final int TYPE_AGGREGATION =2;
	public static final int TYPE_COMMENT=3;

	public Link(Shape nfrom, Shape nto, int type)
	{
		this.from = new LinkInfo(nfrom);
		this.to = new LinkInfo(nto);
		this.type = type;
	}

}
